--- callerid.c	2006-06-02 10:55:26.838045300 -0500
+++ new_callerid.c	2006-06-02 10:55:06.924646900 -0500
@@ -258,7 +258,11 @@
 	int b = 'X';
 	int res;
 	int x;
+
+	//buffer is allocated.
+
 	short *buf = malloc(2 * len + cid->oldlen);
+
 	short *obuf = buf;
 	if (!buf) {
 		ast_log(LOG_WARNING, "Out of memory\n");
@@ -274,11 +278,13 @@
 		res = fsk_serie(&cid->fskd, buf, &mylen, &b);
 		if (mylen < 0) {
 			ast_log(LOG_ERROR, "fsk_serie made mylen < 0 (%d)\n", mylen);
+			free(obuf);
 			return -1;
 		}
 		buf += (olen - mylen);
 		if (res < 0) {
 			ast_log(LOG_NOTICE, "fsk_serie failed\n");
+			free(obuf);
 			return -1;
 		}
 		if (res == 1) {
@@ -307,6 +313,7 @@
 			case 4: /* Retrieve message */
 				if (cid->pos >= 128) {
 					ast_log(LOG_WARNING, "Caller ID too long???\n");
+					free(obuf);
 					return -1;
 				}
 				cid->rawdata[cid->pos++] = b;
@@ -392,6 +399,7 @@
 					strcpy(cid->name, "");
 					cid->flags |= CID_UNKNOWN_NAME;
 				}
+				free(obuf);
 				return 1;
 				break;
 			default:
